/*
 * File   : memory.h
 * Author : Michael Plexousakis, plex@tem.uoc.gr
 * Purpose: Wrappers for the memory allocation/de-allocation routines
*/

#ifndef MEMORY_INCLUDED
#define MEMORY_INCLUDED

#define MALLOC(nbytes)		m_malloc((nbytes), __FILE__, __LINE__)
#define CALLOC(count, nbytes)	m_calloc((count), (nbytes), __FILE__, __LINE__)
#define FREE(ptr)		m_free((ptr), __FILE__, __LINE__)
#define REALLOC(ptr, nbytes)	m_realloc((ptr), (nbytes), __FILE__, __LINE__)
#define STRDUP(s)		m_strdup((s), __FILE__, __LINE__)

extern void *m_malloc(int nbytes, const char *file, int line);
extern void *m_calloc(int count, int nbytes, const char *file, int line);
extern void  m_free(void *ptr, const char *file, int line);
extern void *m_realloc(void *ptr, int nbytes, const char *file, int line);
extern char *m_strdup(const char *src, const char *file, int line);

#endif
